Автор Тема: Проблем с alien  (Прочетена 3155 пъти)

viv1111

  • Напреднали
  • *****
  • Публикации: 250
  • Distribution: Slackware, Ubuntu, Knoppix
  • Window Manager: Gnome
    • Профил
Проблем с alien
« -: Oct 20, 2008, 11:05 »
Ползвам Ubuntu 8.10 beta1, 64 bit. Налага ми се да инсталирам програма, която е в RPM формат за 32 битова архитектура. Alien –to-deb или alien -d не генерират дебиан файл, а генерират директория. По всяка вероятност причината е в това, че програмата под RPM е за 32 битова архитектура, а аз ползвам 64 битова. Ако някой е имал същия проблем и се е справил, моля за помощ. Кажете каква друга информация е необходимо да дам.
Активен

neter

  • Global Moderator
  • Напреднали
  • *****
  • Публикации: 3408
  • Distribution: Debian, SailfishOS, CentOS
  • Window Manager: LXDE, Lipstick
    • Профил
    • WWW
Проблем с alien
« Отговор #1 -: Oct 20, 2008, 12:10 »
Да беше споделил коя е програмата ли... Предполагам не е толкова секретно '<img'> И все пак, да - проблемът ти се дължи от разликата в архитектурата. Не ти ли вади някаква грешка? Дай я, ако има такава. Alien не генерира папка, а просто спира по средата, поради невъзможност да продължи, а папката, която виждаш, съдържа временните файлове, нужни при преобразуването. Конвертирай пакета в 32 битова ОС и после пробвай да го инсталираш на твоята машина. Току виж станало. И все пак да знаехме коя е програмата и каква грешка дава alien... '<img'>
Активен

"Да си добре приспособен към болно общество не е признак за добро здраве" - Джиду Кришнамурти

viv1111

  • Напреднали
  • *****
  • Публикации: 250
  • Distribution: Slackware, Ubuntu, Knoppix
  • Window Manager: Gnome
    • Профил
Проблем с alien
« Отговор #2 -: Oct 20, 2008, 14:47 »
Peter, радвам се, че ти се обади. Историята е малко дълга. Има принтер със скенер – Canon MP520 PIXMA. За линукс изтеглям драйверите от официалния сайт на Canon. Там те са дадени с формат DEB и RPM. Те са четири на брой и са за i386. Тези за принтера (2 броя) инсталирани със dpkg -i –force-all, работят добре. Но тези за скенера не стават. Реших да преобразувам със Alien тези от RPM в DEB, пък може и да заработят. Малко смешна идея, но пък е надежда. Драйверите изтеглям от тук: http://software.canon-europe.com  Първо се инсталира „scangearmp-common-1.10-1.i386.rpm“, а след това другия файл -  „scangearmp-mp520series-1.10-1.i386.rpm“. Но, мисля, че идеята ти да конвергирам пакета в 32 битова ОС ще се окаже добра идея. Дай Боже, някой да направи програма за конвергиране от 32 в 64 бита и обратно. Давам ти и това, което искаш:
root@VIV:/home/lilolin/PROGRAMI# alien --to-deb scangearmp-common-1.10-1.i386.rpm
Warning: Skipping conversion of scripts in package scangearmp-common: postinst postrm
Warning: Use the --scripts parameter to include the scripts.
Package build failed. Here's the log:
dh_testdir
dh_testdir
dh_testroot
dh_clean -k -d
dh_installdirs
dh_installdocs
dh_installchangelogs
find . -maxdepth 1 -mindepth 1 -not -name debian -print0 | \
xargs -0 -r -i cp -a {} debian/scangearmp-common
dh_compress
dh_makeshlibs
dh_installdeb
dh_shlibdeps
dpkg-shlibdeps: warning: symbol dlsym used by debian/scangearmp-common/usr/lib/libsane-canon_mfp.so.1.0.1 found in none of the libraries.
dpkg-shlibdeps: warning: symbol dlclose used by debian/scangearmp-common/usr/lib/libsane-canon_mfp.so.1.0.1 found in none of the libraries.
dpkg-shlibdeps: warning: symbol dlopen used by debian/scangearmp-common/usr/lib/libsane-canon_mfp.so.1.0.1 found in none of the libraries.
dpkg-shlibdeps: failure: couldn't find library libgimp-2.0.so.0 needed by debian/scangearmp-common/usr/local/bin/scangearmp (its RPATH is '''<img'>.
Note: libraries are not searched in other binary packages that do not have any shlibs or symbols file.
To help dpkg-shlibdeps find private libraries, you might need to set LD_LIBRARY_PATH.
dh_shlibdeps: command returned error code 512
make: [binary-arch] Error 1 (ignored)
dh_gencontrol
dpkg-gencontrol: error: current host architecture 'amd64' does not appear in package's architecture list (i386)
dh_gencontrol: command returned error code 65280
make: *** [binary-arch] Error 1
find: „scangearmp-common-1.10“: No such file or directory
Активен

neter

  • Global Moderator
  • Напреднали
  • *****
  • Публикации: 3408
  • Distribution: Debian, SailfishOS, CentOS
  • Window Manager: LXDE, Lipstick
    • Профил
    • WWW
Проблем с alien
« Отговор #3 -: Oct 20, 2008, 15:31 »
Странно... аз като гледам, на сайта си има .deb пакети за скенера на MP520 '<img'> Ето тук най-отдолу, където са и .rpm пакетите, има и .deb пакети. Вярно, пак са i386, ама дръпни ги и ги пробвай. После покажи грешките, ако има такива '<img'>

edit: Забравих да вметна, че инсталирането на .rpm пакети под дистрибуция, която използва .deb пакети по подразбиране, не е невъзможна задача. Инсталирането си се изпълнява със стандартната команда
Примерен код
rpm -ivh пакет

Само дето има малко неприятни главоболия с наместването на зависимости, но при добро желание... '<img'>



Активен

"Да си добре приспособен към болно общество не е признак за добро здраве" - Джиду Кришнамурти

viv1111

  • Напреднали
  • *****
  • Публикации: 250
  • Distribution: Slackware, Ubuntu, Knoppix
  • Window Manager: Gnome
    • Профил
Проблем с alien
« Отговор #4 -: Oct 20, 2008, 15:44 »
Peter, аз по-горе казвам, че има и DEB файлове, но тези, които са за скенера не сработват. С тези за принтера, нямам проблеми при 64 битова ОС. Ето ти резултата за скенера:

root@VIV:/home/lilolin/PROGRAMI/Printer# dpkg -i –force-all scangeagmp-common_1.10-1_i386.deb
dpkg - warning, overriding problem because --force enabled:
package architecture (i386) does not match system (amd64)
(Reading database ... 180359 files and directories currently installed.)
Preparing to replace scangearmp-common 1.10-1 (using scangearmp-common_1.10-1_i386.deb) ...
Unpacking replacement scangearmp-common ...
Setting up scangearmp-common (1.10-1) ...
Processing triggers for libc6 ...
ldconfig deferred processing now taking place



Активен

neter

  • Global Moderator
  • Напреднали
  • *****
  • Публикации: 3408
  • Distribution: Debian, SailfishOS, CentOS
  • Window Manager: LXDE, Lipstick
    • Профил
    • WWW
Проблем с alien
« Отговор #5 -: Oct 20, 2008, 16:07 »
А, вярно, пропуснал съм '<img'> Добре, качваш .deb пакетите (гледам този успява да се качи, предполагам и другия) и какво се случва, когато пробваш да пуснеш sane? Изпълни го от конзолата, за да гледаш за грешки.

P.S.: Между другото, пиша се с N '<img'> Петър не го познавам ':p' '<img'>



Активен

"Да си добре приспособен към болно общество не е признак за добро здраве" - Джиду Кришнамурти

viv1111

  • Напреднали
  • *****
  • Публикации: 250
  • Distribution: Slackware, Ubuntu, Knoppix
  • Window Manager: Gnome
    • Профил
Проблем с alien
« Отговор #6 -: Oct 20, 2008, 16:54 »
Neter, извинявай за името. Когато програмата се инсталира и работи при i386 тя извежда стартов файл в /usr/bin. Програмата libgimp-2.0 е инсталирана. Ето ти резултата при опит за старт от конзола:

root@VIV:/usr/bin# ./scangearmp
./scangearmp: error while loading shared libraries: libgimp-2.0.so.0: cannot open shared object file: No such file or directory



Активен

neter

  • Global Moderator
  • Напреднали
  • *****
  • Публикации: 3408
  • Distribution: Debian, SailfishOS, CentOS
  • Window Manager: LXDE, Lipstick
    • Профил
    • WWW
Проблем с alien
« Отговор #7 -: Oct 20, 2008, 17:16 »
Сега, отиди там, където се намира библиотеката libgimp-2.0.so и й направи symlink в същата папка, като symlink-ът да се казва libgimp-2.0.so.0. Търси библиотеката в някоя от тези папки - /lib, /usr/lib, /usr/lib64. Файлът на библиотеката би трябвало да се казва libgimp-2.0.so.нещо.си. Правиш symlink с такава команда под root
Примерен код
ln -s /папка/libgimp-2.0.so.нещо.си /папка/libgimp-2.0.so.0

След което пробваш отново да изпълниш scangearmp.
Активен

"Да си добре приспособен към болно общество не е признак за добро здраве" - Джиду Кришнамурти

viv1111

  • Напреднали
  • *****
  • Публикации: 250
  • Distribution: Slackware, Ubuntu, Knoppix
  • Window Manager: Gnome
    • Профил
Проблем с alien
« Отговор #8 -: Oct 20, 2008, 17:45 »
Neter, това със символната връзка вече го правих. Файла libgimp-2.0.so се намира в /usr/lib. Работата е там, че отново нищо не става. Ще видя как да оправя този проблем. Благодаря ти за помоща до тук.
Активен

neter

  • Global Moderator
  • Напреднали
  • *****
  • Публикации: 3408
  • Distribution: Debian, SailfishOS, CentOS
  • Window Manager: LXDE, Lipstick
    • Профил
    • WWW
Проблем с alien
« Отговор #9 -: Oct 20, 2008, 17:54 »
Ако ти дава същата грешка за липсващата библиотека, то значи symlink-ът не трябва да е там, където е сега. Явно scangearmp не го вижда там. Пробвай да добавиш symlink със същото име и в другите lib папки '<img'>
Активен

"Да си добре приспособен към болно общество не е признак за добро здраве" - Джиду Кришнамурти

viv1111

  • Напреднали
  • *****
  • Публикации: 250
  • Distribution: Slackware, Ubuntu, Knoppix
  • Window Manager: Gnome
    • Профил
Проблем с alien
« Отговор #10 -: Oct 20, 2008, 19:52 »
Neter, не става и след като добавя symlink-ът и в другите библиотеки (/usr/lib64 и /lib). Ще направя друго. Преди време, след като купих принтера, имах доста тежка кореспонденция със централата на Canon. След около 10 дни те ми изпратиха линк за драйверите за линукс, които бяха изготвили за закупения от мен модел. Сега ще постъпя отново така, пък те да си оправят софтуера. Благодаря ти за помоща, пък нека ония от Canon се оправят.
Активен

neter

  • Global Moderator
  • Напреднали
  • *****
  • Публикации: 3408
  • Distribution: Debian, SailfishOS, CentOS
  • Window Manager: LXDE, Lipstick
    • Профил
    • WWW
Проблем с alien
« Отговор #11 -: Oct 20, 2008, 20:13 »
Опа, забравих само да ти дам един по правилен съвет за случая от предния ми пост - виж със strace къде въпросният scangearmp търси библиотеката и сложи symlink там. Т.е.
Примерен код
strace /usr/bin/scangearmp

Ако нямаш strace, сложи си. Но си е възможно и наистина да има някакъв проблем с драйвера за твоята система, щом от Canon са се дигнали да ти дават друг, така че, ако strace не помогне, стискам ти палци другият им драйвър да ти помогне ':ok:' Май се изчерпах дотук със съветите по въпроса '<img'>
Активен

"Да си добре приспособен към болно общество не е признак за добро здраве" - Джиду Кришнамурти

viv1111

  • Напреднали
  • *****
  • Публикации: 250
  • Distribution: Slackware, Ubuntu, Knoppix
  • Window Manager: Gnome
    • Профил
Проблем с alien
« Отговор #12 -: Oct 20, 2008, 22:51 »
Neter, strace ми даде интересна информация и мисля, че ще се справя. Благодаря ти много. Не бях се сетил до сега да използвам strace.
Активен

Подобни теми
Заглавие Започната от Отговора Прегледи Последна публикация
Alien - конвертор между rpm и deb пакети
Пътят към wiki.linux-bg.org минава оттук
tyuio 4 11010 Последна публикация Feb 04, 2009, 23:52
от phantomlord
Joey Hess напуска Debian и изоставя debhelper, alien, dpkg-repack и debmirror
Коментар
lunarvalley 18 4959 Последна публикация Nov 11, 2014, 22:21
от ray